/**
 * Square Connect API
 * Client library for accessing the Square Connect APIs
 *
 * OpenAPI spec version: 2.0
 * Contact: developers@squareup.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.3.0-SNAPSHOT
 *
 */
var ApiClient = require('../ApiClient');
var Money = require('./Money');




/**
 * The EmployeeWage model module.
 * @module model/EmployeeWage
 */

/**
 * Constructs a new <code>EmployeeWage</code>.
 * The hourly wage rate that an employee will earn on a &#x60;Shift&#x60; for doing the job specified by the &#x60;title&#x60; property of this object.
 * @alias module:model/EmployeeWage
 * @class
 * @param employeeId {String} The `Employee` that this wage is assigned to.
 */
var exports = function(employeeId) {
  var _this = this;


  _this['employee_id'] = employeeId;


};

/**
 * Constructs a <code>EmployeeWage</code> from a plain JavaScript object, optionally creating a new instance.
 * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
 * @param {Object} data The plain JavaScript object bearing properties of interest.
 * @param {module:model/EmployeeWage} obj Optional instance to populate.
 * @return {module:model/EmployeeWage} The populated <code>EmployeeWage</code> instance.
 */
exports.constructFromObject = function(data, obj) {
  if (data) {
    obj = obj || new exports();

      if (data.hasOwnProperty('id')) {
      obj['id'] = ApiClient.convertToType(data['id'], 'String');
    }
      if (data.hasOwnProperty('employee_id')) {
      obj['employee_id'] = ApiClient.convertToType(data['employee_id'], 'String');
    }
      if (data.hasOwnProperty('title')) {
      obj['title'] = ApiClient.convertToType(data['title'], 'String');
    }
      if (data.hasOwnProperty('hourly_rate')) {
      obj['hourly_rate'] = Money.constructFromObject(data['hourly_rate']);
    }
    }
  return obj;
}

/**
 * UUID for this object.
 * @member {String} id
 */
exports.prototype['id'] = undefined;
/**
 * The `Employee` that this wage is assigned to.
 * @member {String} employee_id
 */
exports.prototype['employee_id'] = undefined;
/**
 * The job title that this wage relates to.
 * @member {String} title
 */
exports.prototype['title'] = undefined;
/**
 * Can be a custom-set hourly wage or the calculated effective hourly wage based on annual wage and hours worked per week.
 * @member {module:model/Money} hourly_rate
 */
exports.prototype['hourly_rate'] = undefined;



module.exports = exports;



