/**
 * Square Connect API
 * Client library for accessing the Square Connect APIs
 *
 * OpenAPI spec version: 2.0
 * Contact: developers@squareup.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.3.0-SNAPSHOT
 *
 */
var ApiClient = require('../ApiClient');




/**
 * The ShiftSort model module.
 * @module model/ShiftSort
 */

/**
 * Constructs a new <code>ShiftSort</code>.
 * Sets the sort order of search results.
 * @alias module:model/ShiftSort
 * @class
 */
var exports = function() {
  var _this = this;



};

/**
 * Constructs a <code>ShiftSort</code> from a plain JavaScript object, optionally creating a new instance.
 * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
 * @param {Object} data The plain JavaScript object bearing properties of interest.
 * @param {module:model/ShiftSort} obj Optional instance to populate.
 * @return {module:model/ShiftSort} The populated <code>ShiftSort</code> instance.
 */
exports.constructFromObject = function(data, obj) {
  if (data) {
    obj = obj || new exports();

      if (data.hasOwnProperty('field')) {
      obj['field'] = ApiClient.convertToType(data['field'], 'String');
    }
      if (data.hasOwnProperty('order')) {
      obj['order'] = ApiClient.convertToType(data['order'], 'String');
    }
    }
  return obj;
}

/**
 * The field to sort on. See [ShiftSortField](#type-shiftsortfield) for possible values
 * @member {module:model/ShiftSort.FieldEnum} field
 */
exports.prototype['field'] = undefined;
/**
 * The order in which results are returned. Defaults to DESC. See [SortOrder](#type-sortorder) for possible values
 * @member {module:model/ShiftSort.OrderEnum} order
 */
exports.prototype['order'] = undefined;


  /**
   * Allowed values for the <code>field</code> property.
   * @enum {String}
   * @readonly
   */
  exports.FieldEnum = {
    /**
     * value: "START_AT"
     * @const
     */
    "START_AT": "START_AT",
    /**
     * value: "END_AT"
     * @const
     */
    "END_AT": "END_AT",
    /**
     * value: "CREATED_AT"
     * @const
     */
    "CREATED_AT": "CREATED_AT",
    /**
     * value: "UPDATED_AT"
     * @const
     */
    "UPDATED_AT": "UPDATED_AT"  };

  /**
   * Allowed values for the <code>order</code> property.
   * @enum {String}
   * @readonly
   */
  exports.OrderEnum = {
    /**
     * value: "DESC"
     * @const
     */
    "DESC": "DESC",
    /**
     * value: "ASC"
     * @const
     */
    "ASC": "ASC"  };


module.exports = exports;



